create table if not exists acs.ports (
    name varchar(256) primary key,
    origin uuid not null,
    lane varchar(128),
    direction varchar(32),
    fromzone int not null,
    tozone int not null
);

alter table acs.ports alter column name set storage plain;
alter table acs.ports alter column lane set storage plain;
alter table acs.ports alter column direction set storage plain;

DO $$
BEGIN
IF to_regclass('acs.i_port_ident') IS NULL THEN
    CREATE UNIQUE INDEX i_port_ident ON acs.ports USING btree (origin, lane, direction);
END IF;
END$$;


