
create or replace function hwp.t_issue_action() returns trigger as $$
declare
	_os integer;
	_ns integer;
	r record;
begin
	if TG_OP = 'INSERT' then
		insert into _os status from hwp.issues where id = new.iid;
		if not found then
			return null;
		end if;
		insert into r * from hwp.issue_mask where action = new.action;
		if not found then
			return new;
		end if;
		_ns := _os;
		if _os = 0 then
			_ns = r.setmask;
		else
			if _os & r.resetmask > 0 then
				_ns = (_os & ~r.resetmask) | r.setmask;
			end if;
		end if;
		if _ns is distinct from _os then
			update hwp.issues set status = _ns where id = new.iid;
		end if;	
		new.status := _ns;
		return new;
	elsif TG_OP = 'DELETE' then
		select into _os status from hwp.issue_log where iid = old.iid and moment < old.moment order by moment desc limit 1;
		if not found then 
			_os := 0;
		end if;
		for r in select i.moment,i.action,m.setmask,m.resetmask from hpw.issue_log i left join hpw.issue_mask m on m.action = i.action where i.iid = old.iid and i.moment > old.moment order by i.moment loop
			if _os & r.resetmask > 0 then
				_os := (_os & ~r.resetmask) | r.setmask;
			end if;	
			update hwp.issue_log set status = _os where iid = old.iid and moment = r.moment;
		end loop;
		update hwp.issues set status = _os where di = old.iid;
		return old;
	else
		return null;
	end if;
end;
$$ language plpgsql;




