create table if not exists hwp.watchlistitems (
    owner   varchar(128) not null,
    ident   varchar(128) not null,
    plate   varchar(128) not null,
    class   varchar(128),
    color   varchar(128),
    make    varchar(128),
    model   varchar(218),
    alarm   varchar(32),
    memo    text,
    meta    json
);

create table if not exists hwp.watchlistarchive (
    archived    timestamptz not null default now()
) inherits (hwp.watchlistitems);    


alter table hwp.watchlistitems alter column owner  set storage plain;
alter table hwp.watchlistitems alter column ident  set storage plain;
alter table hwp.watchlistitems alter column plate  set storage plain;
alter table hwp.watchlistitems alter column class  set storage plain;
alter table hwp.watchlistitems alter column color  set storage plain;
alter table hwp.watchlistitems alter column make   set storage plain;
alter table hwp.watchlistitems alter column model  set storage plain;
alter table hwp.watchlistitems alter column alarm  set storage plain;
alter table hwp.watchlistitems alter column memo   set storage plain;  


DO $$
BEGIN
    IF to_regclass('hwp.i_watchlist_ident') IS NULL THEN
        CREATE INDEX i_watchlist_ident ON hwp.watchlistitems USING btree (owner,ident);
    END IF;
    IF to_regclass('hwp.i_watchlist_plate_btree') IS NULL THEN
        CREATE INDEX i_watchlist_plate_btree ON hwp.watchlistitems USING btree (plate);
    END IF;
    IF to_regclass('hwp.i_watchlist_plate_trgm') IS NULL THEN
        CREATE INDEX i_watchlist_plate_trgm ON hwp.watchlistitems USING gin (plate COLLATE pg_catalog."default" ct.gin_trgm_ops);
    END IF;
    IF to_regclass('hwp.i_watchlistarchive_ident') IS NULL THEN
        CREATE INDEX i_watchlistarchive_ident ON hwp.watchlistarchive USING btree (owner,ident);
    END IF;
END $$;


