CREATE or replace FUNCTION lib.version_(test character varying, v1 character varying, v2 character varying) RETURNS boolean
    LANGUAGE plpgsql
    AS $$
begin
	if test = 'equ' or test = '=' then
		return 
			coalesce(lib.version_part('major',v1),0) 	= coalesce(lib.version_part('major',v2),0) and
			coalesce(lib.version_part('minor',v1),0) 	= coalesce(lib.version_part('minor',v2),0) and
			coalesce(lib.version_part('tiny',v1) ,0) 	= coalesce(lib.version_part('tiny', v2),0) and
			coalesce(lib.version_part('revision',v1),0) 	= coalesce(lib.version_part('revision',v2),0)
		;	
	elsif test = 'gt' or test = '>' or test = 'ge' or test = '>=' then
		if coalesce(lib.version_part('major',v1),0) > coalesce(lib.version_part('major',v2),0) then return true; end if;
		if coalesce(lib.version_part('major',v1),0) < coalesce(lib.version_part('major',v2),0) then return false; end if; 
		if coalesce(lib.version_part('minor',v1),0) > coalesce(lib.version_part('minor',v2),0) then return true; end if;
		if coalesce(lib.version_part('minor',v1),0) < coalesce(lib.version_part('minor',v2),0) then return false; end if;
		if coalesce(lib.version_part('tiny', v1),0) > coalesce(lib.version_part('tiny', v2),0) then return true; end if;
		if coalesce(lib.version_part('tiny', v1),0) < coalesce(lib.version_part('tiny', v2),0) then return false; end if;
		if coalesce(lib.version_part('revision',v1),0) > coalesce(lib.version_part('revision',v2),0) then return true; end if;
		if test = 'gt' or test = '>' then 
			return false; 
		else
			return coalesce(lib.version_part('revision',v1),0) = coalesce(lib.version_part('revision',v2),0);
		end if;
	elsif test = 'lt' or test = '<' or test = 'le' or test = '<=' then
		if coalesce(lib.version_part('major',v1),0) < coalesce(lib.version_part('major',v2),0) then return true; end if;
		if coalesce(lib.version_part('major',v1),0) > coalesce(lib.version_part('major',v2),0) then return false; end if; 
		if coalesce(lib.version_part('minor',v1),0) < coalesce(lib.version_part('minor',v2),0) then return true; end if;
		if coalesce(lib.version_part('minor',v1),0) > coalesce(lib.version_part('minor',v2),0) then return false; end if;
		if coalesce(lib.version_part('tiny', v1),0) < coalesce(lib.version_part('tiny', v2),0) then return true; end if;
		if coalesce(lib.version_part('tiny', v1),0) > coalesce(lib.version_part('tiny', v2),0) then return false; end if;
		if coalesce(lib.version_part('revision',v1),0) < coalesce(lib.version_part('revision',v2),0) then return true; end if;
		if test = 'lt' or test = '<' then 
			return false; 
		else
			return coalesce(lib.version_part('revision',v1),0) = coalesce(lib.version_part('revision',v2),0);
		end if;
	else
		raise '[version] test unknown';
		return null;
	end if;		
	return false;
end;		
$$;
