CREATE or replace FUNCTION lib.version_part(ipart character varying, iversion character varying) RETURNS integer
    LANGUAGE plpgsql
    AS $$
declare 
	ar varchar[];
begin
	iversion = btrim(iversion); ipart = lower(btrim(ipart));
	if ( iversion !~ E'^[0-9]+\.[0-9]+(\.[0-9]+)?(\.[0-9]+)?' ) then
		raise '[version] invalid syntax';
		return null;
	end if;	
	if ( not ipart = any(array['major','minor','tiny','revision']) ) then
		raise '[version] invalid part';
		return null;
	end if;	
	ar = regexp_split_to_array(iversion,E'\\.');
	if ipart = 'major' then
		return ar[1]::integer;
	elsif ipart = 'minor' then
		return ar[2]::integer;
	elsif ipart = 'tiny' then
		if array_length(ar,1) < 3 then
			raise '[version] part not found';
			return null;
		end if;
		return ar[3]::integer;			
	elsif ipart = 'revision' then
		if array_length(ar,1) < 4 then
			raise '[version] part not found';
			return null;
		end if;
		return ar[4]::integer;			
	end if;	
	return null;
end;
$$;

