create table if not exists public.valuestore (
    section varchar not null,
    key varchar not null,
    value jsonb,
    primary key (section,key)
);


create or replace rule 
	r_valuestore_set
as on insert to public.valuestore 
where exists (select 1 from public.valuestore where section = new.section and key = new.key)
do instead (
	update public.valuestore set value = new.value where section = new.section and key = new.key;
);

create or replace rule 
	r_valuestore_clean
as on update to public.valuestore 
where new.value is null 
do instead (
	delete from public.valuestore where section = new.section and key = new.key;
);
