CREATE or replace FUNCTION service.maintenance_info(OUT _key text, OUT _value text) RETURNS SETOF record
    LANGUAGE plpgsql
    AS $$
declare
	r record;
begin
	perform true from core.lock where name = 'maintenance.info' for update nowait;
	update core.lock set lastlock = clock_timestamp() where name = 'maintenance.info';
	
	select into _key, _value  E'now', now()::text;
	return next;
	
	select into _key, _value E'check_eventindex_age', (now()-min(ctime))::text from eventindex where id > 1;
	insert into service.maintenance_log ( key, value ) values ( _key, _value );
	return next;
	
	select into _key, _value E'check_eventindex_interval', age::text from service.maintenance_clipage where "table" = 'eventindex';
	insert into service.maintenance_log ( key, value ) values ( _key, _value );
	return next;
	
	select into _key, _value E'check_volume_free_space', pg_size_pretty(lib.getvolumefreespace(_s('_datadir'))::bigint)::text;
	insert into service.maintenance_log ( key, value ) values ( _key, _value );
	return next;
	
	select into _key, _value E'check_db_size', lib.getdirsize(_s('_datadir'))::text;
	insert into service.maintenance_log ( key, value ) values ( _key, _value );
	return next;

	update core.lock set lastrelease = clock_timestamp() where name = 'maintenance.info';

exception when lock_not_available then
	insert into service.maintenance_log ( key, value ) values ( E'INFO_LOCK', E'duplicate instance' );
end;
$$;

