
do language plpythonu $$

import glob
import os
import shutil

try:
    rv = plpy.execute("select "
                      "current_setting('local.dbdir') as dbdir, "
                      "current_setting('local.dbuser') as dbuser, "
                      "current_setting('local.contribdir') as contribdir, "
                      "current_setting('local.contriblibdir') "
                      "as contriblibdir", 1)
    dbdir = rv[0]['dbdir']
    dbuser = rv[0]['dbuser']
    contribdir = rv[0]['contribdir']
    contriblibdir = rv[0]['contriblibdir']
    filename = ''
    schemas = ['_prefix'] + [line.lower().split('exists ')[1].split(';')[0]
                             for line in
                             open(os.path.join(dbdir, "structure",
                                               "schemas.sql")) if line] + \
              ['public', '_suffix']
    parts = ['tables', 'views', 'functions', 'triggers', 'alter', 'data']
    for schema in schemas:
        spath = os.path.join(dbdir, "structure", "schema", schema)
        if os.path.exists(spath):
            if os.path.exists(os.path.join(spath, ".comment")):
                with open(os.path.join(spath, ".comment"), "r") as cf:
                    com = cf.read()
                plpy.execute("comment on schema {0} is {1};"
                             .format(plpy.quote_ident(schema),
                                     plpy.quote_literal(com)))
            for part in parts:
                ppath = os.path.join(spath, part)
                if os.path.exists(ppath):
                    for filename in sorted(glob.glob(os.path.join(ppath,
                                                                  "*.sql"))):
                        try:
                            with open(filename, 'r') as sqlfile:
                                sqlscript = sqlfile.read()
                            pschema = schema
                            if pschema.find("_") >= 0:
                                pschema = "public"
                            plpy.execute('set search_path = {0},'
                                         ' pg_catalog; {1}'.format(pschema,
                                                                   sqlscript),
                                         0)
                        except Exception as ex:
                            raise plpy.Error("E:structure:[{0}]:{1}"
                                             .format(filename, ex))

except Exception as ex:
    raise plpy.Error("E:structure:{0}".format(ex))
		
$$;

