
do language plpythonu $$

import glob
import os
import re
import shutil

def verint(mj, mn, rl):
	return mj * 100000000 + mn * 10000 + rl

filename = ""

try:
    dbdir = GD['local']['dbdir']
    dbuser = GD['local']['dbuser']
    contribdir = GD['local']['contribdir']
    contriblibdir = GD['local']['contriblibdir']

    mymajor = int(GD['local']['version_major'])
    myminor = int(GD['local']['version_minor'])
    myrelease = int(GD['local']['version_release'])

    rv = plpy.execute("select * from information_schema.tables "
                      "where table_schema = 'core' and "
                      "table_name = 'version'", 1)
    if rv.nrows() > 0:
        rv = plpy.execute("select * from core.version "
                          "order by moment desc limit 1", 1)
        if rv.nrows() > 0 and 'release' in rv[0]:
            if (verint(mymajor, myminor, myrelease) <
                    verint(rv[0]['major'], rv[0]['minor'], rv[0]['release'])):
                raise Exception('Illegal version downgrade {0} -> {1}'
                                .format([rv[0]['major'], rv[0]['minor'],
                                         rv[0]['release']],
                                        [mymajor, myminor, myrelease]))

    plpy.execute("create table _update_tails ( id serial, tail text );", 0)
    for filename in sorted(
            filter(lambda x: re.match("^.*up-\d+\.\d+\.\d+-", x),
                   glob.glob(os.path.join(dbdir, "updates", "*.sql"))),
            key=lambda x: tuple([int(y) for y in x.split('-')[1].split('.')
                                 if y.isdigit()])):
        with open(filename, 'r') as updatefile:
            updatescript = updatefile.read()
        plpy.execute(updatescript, 0)

except Exception as ex:
    raise plpy.Error("E:updates:{0}: {1}".format(filename, ex))
		
$$;

